
/**
 * Ҷ
 * QQȺ121376426
 * http://blog.yundiantech.com/
 */

#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QUdpSocket>
#include <QHostInfo>
#include <QMessageBox>
#include <QScrollBar>
#include <QDateTime>
#include <QNetworkInterface>
#include <QProcess>

#include <QMainWindow>
#include <QPropertyAnimation>

#include "widget/selectrect.h"
#include "video/screenrecorder.h"

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:

    enum RecoderState
    {
        Recording,
        Pause,
        Stop
    };

    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

public slots:
    void showOut();

protected:
    void closeEvent(QCloseEvent *);

protected:
    void mousePressEvent(QMouseEvent *);
    void mouseMoveEvent(QMouseEvent *);
    void mouseReleaseEvent(QMouseEvent *);

private:
    Ui::MainWindow *ui;

    bool isLeftBtnPressed;
    QPoint dragPosition;

    QPropertyAnimation *animation; // ʵִϷ

    QString mSaveFileDir; //ƵĿ¼
    QString mCurrentFilePath; //ǰ¼ƵƵļ·

    ScreenRecorder *m_screenRecorder;
    QRect deskRect; //С
    SelectRect *selectRectWidget;  //ѡĿؼ
    QRect rect; //ǰ¼Ƶ
    float m_rate; //Ļ߱

    QTimer * m_timer; //ʱ ڻȡʱ

    RecoderState m_recordeState;

    void initDev(); //ȡ¼豸б

    void loadConfigFile(); //ļ
    void saveConfigFile(); //дļ

    bool startRecord();
    bool pauseRecord();
    bool stopRecord();

private slots:
    void slotToolBtnToggled(bool);
    void slotBtnClicked();

    ///ѡ¼ - Begin
    void slotSelectRectBtnClick();
    void slotEditRectBtnClick();
    void slotHideRectBtnClick();
    void slotSelectRectFinished(QRect);
    ///ѡ¼ - End

    void slotTimerTimeOut();

    void slotCheckBoxClick(bool checked);
};

#endif // MAINWINDOW_H
